// Fix map for IE
if (!('map' in Array.prototype)) {
	Array.prototype.map = function(mapper, that /* opt */) {
		var other = new Array(this.length);
		for ( var i = 0, n = this.length; i < n; i++)
			if (i in this)
				other[i] = mapper.call(that, this[i], i, this);
		return other;
	};
};

var browser = BrowserDetect;
var mwidth = 280;
var wordcloud, size = [ mwidth + 20, mwidth + 20 ], cloudid = null;
var maxterms = 50;
var wsel = 1;
var weights;
var p = 2;

if (isOldBrowser()) {
	$('#old_browser_msg').show();
	$('#wtf').hide();
	$('fieldset#state').addClass('ff3');
	$('#ie8_percents').addClass('ff3');
	$('#share2').addClass('ff3');
	$('#poweredby.old_browsers').show();
}

var jsondir = 'jsonlob';

var mp;

var buckets = 9, colorScheme = 'rbow1';
var rown = 15;
var minmax;
var fillColor;
var colors = [
		[ "#66C2A5", "#ABDDA4", "#E6F598", "#f6faaa", "#FEE08B", "#FDAE61",
				"#F46D43", "#D53E4F", "#9E0142" ],
		[ "#5E4FA2", "#3288BD", "#66C2A5", "#ABDDA4", "#FEE08B", "#FDAE61",
				"#F46D43", "#D53E4F", "#9E0142" ] ];

d3.json(jsondir + '/config.json', function(json) {
	mp = json;
	init();
});

function init() {
	d3.json(jsondir + '/minmax.json', function(json) {
		minmax = json;
		minf = Math.min(minmax[1].tfreq.min[wsel], minmax[0].tfreq.min[wsel]);
		maxf = Math.max(minmax[1].tfreq.max, minmax[0].tfreq.max);
		fillColor = d3.scale.quantile().domain(
				[ Math.log(minf), Math.log(maxf) ]).range(colors[1]);
		initializeMatrix(0, 0);
		loadCloud(0);
		initializeMatrix(1, 0);
		loadCloud(1);
		initializeMatrix(2, 0);
		loadCloud(2);

		createKey('#ckey0', 0, 0, minmax[0].cdist.min, minmax[0].cdist.max,
				linHeight);
		createKey('#ckey2', 1, 0, minf, maxf, logHeight);
		createKey('#ckey1', 0, 1, minmax[1].cdist.min, minmax[1].cdist.max,
				linHeight);
		createKey('#ckey3', 1, 1, minf, maxf, logHeight);
	});
}

function initializeMatrix(n, c) {
	d3.select('#vis' + n).classed(colorScheme, true);
	d3.json(jsondir + '/' + mp[n].file, function(json) {
		mp[n].data = json;
		createTiles(n, c);
		reColorTiles(n);
		initMouseOver(n);
	})
}

function initMouseOver(n) {

	// headers mouseover events
	$('#tiles' + n + ' th').hover(function() {

		$(this).addClass('sel');

	}, function() {

		$(this).removeClass('sel');

	});

	// tiles mouseover events
	$('#tiles' + n + ' td').hover(function() {
		$(this).addClass('sel');
		addSel($(this), 'sel');
	}, function() {
		$(this).removeClass('sel');
		removeSel($(this), 'sel');
	});
	// tiles click events
	$('#tiles' + n + ' td')
			.click(
					function() {
						var id = $(this).attr('id');
						var tmp = $(this).attr('id').split(/[a-z]/), number = parseInt(tmp[1]), day = parseInt(tmp[2]), hour = parseInt(tmp[3]);
						if (n > 0) {
							var oldsel1 = $('#' + mp[n].sel1);
							oldsel1.removeClass('sel' + n);
							removeSel(oldsel1, 'sel1');
							addSel($(this), 'sel1');
							mp[n].sel1 = id;
							$(this).addClass('sel' + n);
							var ftmp = mp[n].tfile.split(/\//);
							mp[n].tfile = ftmp[0] + "/terms_"
									+ formatInteger(day, 3) + "_"
									+ formatInteger(hour, 3) + ".json";
							loadCloud(n);
						} else {
							var oldsel2 = $('#' + mp[n].sel2);
							var oldsel1 = $('#' + mp[n].sel1);
							removeSel(oldsel1, 'sel1');
							addSel($(this), 'sel1');
							oldsel2.children().children().eq(1).text("");
							oldsel2.removeClass('sel2');
							oldsel1.children().children().eq(1).text("");
							oldsel1.removeClass('sel1');
							oldsel1.children().children().eq(1).text("2");
							oldsel1.addClass('sel2');
							mp[n].sel2 = oldsel1.attr('id');
							mp[n].sel1 = id;
							$(this).addClass('sel1');
							addSel($(this), 'sel1');
							if (mp[n].sel1 == mp[n].sel2) {
								$(this).children().children().eq(1)
										.text("\xBD");
							} else {
								$(this).children().children().eq(1).text("1");
							}
							switchMatrix(day, hour);
						}
					});
}

function loadCloud(n) {
	d3.json(jsondir + '/' + mp[n].tfile, function(json) {
		var termlist = json.terms;
		var taglist = new Array();
		var length = termlist.length;
		var d = n;
		if (d > 1) {
			d = 1;
		}
		var maxfreq = minmax[d].tfreq.max;
		var minfreq = minmax[d].tfreq.min[wsel];
		weights = {};
		for ( var i = 0; i < maxterms; i++) {
			taglist.push({
				'text' : termlist[i][0],
				'size' : termlist[i][1]
			});
			weights[termlist[i][0]] = termlist[i][2];
		}
		var fontSize = d3.scale.log().domain(
				[ minmax[d].tdist.min[wsel], minmax[d].tdist.max ]).range(
				[ 5, 70 ]);
		cloudid = '#cloud' + n;
		$(cloudid).empty();
		d3.layout.cloud().size(size).words(taglist).fontSize(function(d) {
			return fontSize(+d.size);
		}).spiral('rectangular')
		// .rotate(function() { return ~~(Math.random() * 2) * 90; })
		.rotate(function() {
			return 0;
		}).on("end", draw).start();
		var termtitle = json.title;
		$(cloudid).append(
				'<div style="text-align:center" id="title' + n + '">'
						+ termtitle + '</div>');
	});
}

function draw(words) {
	wordcloud = d3.select(cloudid).append("svg").attr("width", size[0]).attr(
			"height", size[1]).append("g").attr("transform",
			"translate(" + (size[0] / 2) + "," + (size[1] / 2) + ")");
	wordcloud.selectAll("text").data(words).enter().append("text").style(
			"font-size", function(d) {
				return d.size + "px";
			}).style("fill", function(d) {
		return fillColor(Math.log(weights[d.text]));
	}).attr("text-anchor", "middle").attr("transform", function(d) {
		return "translate(" + [ d.x, d.y ] + ")rotate(" + d.rotate + ")";
	}).text(function(d) {
		return d.text;
	});
}

function reloadMatrix(n) {
	d3.json(jsondir + '/' + mp[n].file, function(json) {
		mp[n].data = json;
		reColorTiles(n);
	});
}

function switchMatrix(day, hour) {
	var auxfile = mp[1].file;
	mp[1].file = "dir_" + formatInteger(day, 3) + "_"
			+ formatInteger(hour, 3) + "/matrix.json";
	reloadMatrix(1);
	mp[2].file = auxfile;
	reloadMatrix(2);
	mp[0].tfile = "terms_" + formatInteger(day, 3) + "_"
			+ formatInteger(hour, 3) + ".json";
	loadCloud(0);
	var ftmp1 = mp[1].tfile.split(/\//);
	mp[1].tfile = "dir_" + formatInteger(day, 3) + "_"
			+ formatInteger(hour, 3) + "/" + ftmp1[1];
	loadCloud(1);
	var tmp = mp[0].sel2.split(/[a-z]/), n = parseInt(tmp[1]), d = parseInt(tmp[2]), h = parseInt(tmp[3]);
	var ftmp2 = mp[2].tfile.split(/\//);
	mp[2].tfile = "dir_" + formatInteger(d, 3) + "_"
			+ formatInteger(h, 3) + "/" + ftmp2[1];
	loadCloud(2);
}

/* ************************** */

function selectedType() {

	// return d3.select('input[name="type"]:checked').property('value'); // IE8
	// doesn't like this
	return $('input[name="type"]:checked').val();
}

/* ************************** */

function getCalcs(n) {

	var d = n;
	if (d > 1) {
		d = 1;
	}
	return {
		'min' : minmax[d].cdist.min * 0.99,
		'max' : minmax[d].cdist.max
	};
};

/* ************************** */

function reColorTiles(n) {

	var calcs = getCalcs(n), range = [];

	for ( var i = 1; i <= buckets; i++) {
		range.push(i);
	}

	var data = mp[n].data;

	$('#title' + n).text(mp[n].data.title);

	var bucket = d3.scale.quantize().domain(
			[ calcs.min, calcs.max > 0 ? calcs.max : 1 ]).range(range), side = d3
			.select('#tiles' + n).attr('class');

	if (side === 'front') {
		side = 'back';
	} else {
		side = 'front';
	}

	for ( var x = 0; x < data.matrix.length; x++) {
		for ( var y = 0; y < data.matrix[x].length; y++) {

			var sel = '#n' + n + 'd' + x + 'h' + y + ' .tile .' + side, val = data.matrix[x][y];

			// erase all previous bucket designations on this cell
			for ( var i = 1; i <= buckets; i++) {
				var cls = 'q' + i + '-' + buckets;
				d3.select(sel).classed(cls, false);
			}

			// set new bucket designation for this cell
			var cls = 'q' + (val > 0 ? bucket(val) : 0) + '-' + buckets;
			d3.select(sel).classed(cls, true);
		}
	}
	flipTiles(n);
}

/* ************************** */

function flipTiles(n) {

	var oldSide = d3.select('#tiles' + n).attr('class'), newSide = '';

	if (oldSide == 'front') {
		newSide = 'back';
	} else {
		newSide = 'front';
	}

	var flipper = function(n, h, d, side) {
		return function() {
			var sel = '#n' + n + 'd' + d + 'h' + h + ' .tile', rotateY = 'rotateY(180deg)';

			if (side === 'back') {
				rotateY = 'rotateY(0deg)';
			}
			if (browser.browser === 'Safari' || browser.browser === 'Chrome') {
				d3.select(sel).style('-webkit-transform', rotateY);
			} else {
				d3.select(sel).select('.' + oldSide).classed('hidden', true);
				d3.select(sel).select('.' + newSide).classed('hidden', false);
			}

		};
	};

	data = mp[n].data;

	for ( var x = 0; x < data.matrix.length; x++) {
		for ( var y = 0; y < data.matrix[x].length; y++) {
			var side = d3.select('#tiles' + n).attr('class');
			setTimeout(flipper(n, x, y, side), (x * 30) + (y * 30)
					+ (Math.random() * 100));
		}
	}
	d3.select('#tiles' + n).attr('class', newSide);
}

/* ************************** */

function createTiles(n, s) {
	var data = mp[n].data;
	// var html = '<p style="text-align:center" id="title' + n + '">'
	// + data.title + '</p>' + '<table id="tiles' + n + '" class="front">';
	var html = '<table id="tiles' + n
			+ '" class="front"><tr><td><div>&nbsp;</div></td>'
			+ '<td id="title' + n + '"style="text-align:center" colspan="'
			+ data.matrix.length + '">' + data.title + '</td></tr>';
	var width = mwidth / data.matrix.length;
	var w = width - 2;
	var fs = width * 0.9;
	var w1 = width - 6;

	html += '<tr><th><div>&nbsp;</div></th>';
	for ( var x = 0; x < data.matrix.length; x++) {
		html += '<th class="h" id="x' + n + 'h' + x + '">'
				+ '<div style="width:' + w1 + 'px;max-width:' + w1 + 'px">'
				+ data.xlabels[x] + '</div>' + '</th>';
	}
	html += '</tr>';

	for ( var y = 0; y < data.matrix.length; y++) {
		html += '<tr class="d">';
		html += '<th id="y' + n + 'd' + y + '">'
				+ '<div style="text-align:right;width:40px;height:' + w1
				+ ';max-height:' + w1 + 'px">' + data.ylabels[y]
				+ '&nbsp;</div></th>';
		for ( var x = 0; x < data.matrix.length; x++) {
			html += '<td id="n' + n + 'd' + y + 'h' + x + '" class="d' + y
					+ ' x' + x + '"><div class="tile" style="width:' + width
					+ 'px;height:' + width
					+ 'px"><div class="face front" style="width:' + w
					+ 'px;height:' + w
					+ 'px"></div><div class="face back" style="width:' + w
					+ 'px;height:' + w + 'px;font-size:' + fs
					+ 'px;line-height:' + w + 'px"></div></div></td>';
		}
		html += '</tr>';
	}

	html += '</table>';
	d3.select('#vis' + n).html(html);
	if (n == 0) {
		var node = $('#' + mp[n].sel1);
		node.addClass('sel1');
		node.children().children().eq(1).text("1");
		addSel(node, 'sel1');
		node = $('#' + mp[n].sel2);
		node.addClass('sel2');
		node.children().children().eq(1).text("2");
	} else if (n == 1) {
		var node = $('#' + mp[n].sel1);
		node.addClass('sel1');
		addSel(node, 'sel1');

	} else {
		var node = $('#' + mp[n].sel1);
		node.addClass('sel2');
		addSel($('#' + mp[n].sel1), 'sel1');
	}
}

function createKey(ckey, c, s, min, max, fheight) {
	var html = '<table style="padding:0px">';
	var min1 = min;
	var max1 = max;
	if (c == 1) {
		min1 *= 100;
		max1 *= 100;
	}
	for ( var y = colors[c].length - 1; y >= 0; y--) {
		html += '<tr class="d">';
		var color = '<td><div class="tile" style="width:' + (mwidth / rown)
				+ 'px;height:' + fheight(y, colors[c].length)
				+ 'px;background-color:' + colors[c][y] + ';"></div></td>';
		var key = '<th style="vertical-align:middle"><div style="width:auto;height:'
				+ 10 + 'px;">';
		if (y == 0) {
			key = '<th style="vertical-align:bottom"><div style="width:auto;height:'
					+ 10 + 'px;">' + min1.toFixed(p);
		} else if (y == (colors[c].length - 1) / 2) {
			key = '<th style="vertical-align:middle"><div style="width:auto;height:'
					+ 10
					+ 'px;">'
					+ (min1 + (max1 - min1) / 2).toFixed(p)
					+ '</div></td>';
		} else if (y == (colors[c].length - 1)) {
			key = '<th style="vertical-align:top"><div style="width:auto;height:'
					+ 10 + 'px;">' + max1.toFixed(p);
		} else {
			key = '<th><div style="height:' + 10 + 'px">';
		}
		key += '</div></td>';
		if (s == 0) {
			html += key + '<td><div style="height:10px">&nbsp;</div></td>'
					+ color;
		} else {
			html += color + '<td><div style="height:10px">&nbsp;</div></td>'
					+ key;
		}
		html += '</tr>';
	}
	html += '</table>';
	d3.select(ckey).html(html);
}

/* ************************** */

function isOldBrowser() {

	var result = false;
	if (browser.browser === 'Explorer' && browser.version < 9) {
		result = true;
	} else if (browser.browser === 'Firefox' && browser.version < 4) {
		result = true;
	}

	// console.log(result);

	return result;
}

function formatInteger(x, n) {
	var result = "";
	var nstring = x.toString();
	for ( var i = 0; i < n - nstring.length; i++) {
		result = result + "0";
	}
	return result + nstring;
}

function getTopPos(el) {
	// alert(el.attr('id'));
	for ( var ly = 0; el != null; ly += el.offsetTop, el = el.offsetParent)
		;
	return ly;
}

function log(val, base) {
	return Math.log(val) / Math.log(base);
}

function linHeight(x, y) {
	return mwidth / y;
}

function logHeight(x, y) {
	return mwidth * (log(x + 2, y + 2) - log(x + 1, y + 2));
}

function addSel(obj, sel) {
	var tmp = obj.attr('id').split(/[a-z]/), n = parseInt(tmp[1]), d = parseInt(tmp[2]), h = parseInt(tmp[3]);
	$('#x' + n + 'h' + h).addClass(sel);
	$('#y' + n + 'd' + d).addClass(sel);
}

function removeSel(obj, sel) {
	var tmp = obj.attr('id').split(/[a-z]/), n = parseInt(tmp[1]), d = parseInt(tmp[2]), h = parseInt(tmp[3]);
	$('#x' + n + 'h' + h).removeClass(sel);
	$('#y' + n + 'd' + d).removeClass(sel);
}